#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void usage(const char *progname) {
    fprintf(stderr, "USAGE: %s <positive number>\n", progname);
    exit(1);
}

void generate_permutations(int *perm, int *available, int i, int n) {
    if (i < n) { 
        for (int j = 0; j < n; ++j) {
            if (available[j]) {
                available[j] = 0;
                perm[i] = j + 1;
                generate_permutations(perm, available, i + 1, n);
                available[j] = 1;
            }
        }
    } else {
        for (int j = 0; j < n; ++j) {
            printf("%d ", perm[j]);
        }
        printf("\n");
    }
}

int main(int argc, const char **argv) {
    int n, nchars, nitems;

    // Check that the right number of arguments was given
    if (argc != 2) {
        usage(argv[0]);
    }

    // Check that the one provided argument is a valid unsigned integer
    nitems = sscanf(argv[1], "%d%n", &n, &nchars);
    if (nitems != 1 || nchars != strlen(argv[1]) || n < 1) {
        usage(argv[0]);
    }

    int perm[n];      // The array where we store the permutation to be printed
    int available[n]; // The "bit" array that indicates which numbers can still
                      // be chosen.

    for (int i = 0; i < n; available[i++] = 1);

    generate_permutations(perm, available, 0, n);

    return 0;
}
